local class = select(2, UnitClass("player"))

--Let's create our FoF tracker!
local function FrostyEmbrace_CreateFoF(data)
    local frame = CreateFrame("Frame", "FrostyEmbrace_FoF", UIParent)
    frame:SetWidth(10)
    frame:SetHeight(10)
    frame:SetPoint(unpack(data.setPoint))
    frame:RegisterEvent("UNIT_AURA")
	frame:RegisterEvent("PLAYER_REGEN_DISABLED") -- hopefully fixes 7.2.5 issues
    frame:RegisterEvent("PLAYER_TARGET_CHANGED")
    frame:RegisterEvent("PLAYER_ENTERING_WORLD")
    frame:SetScript("OnEvent", function(self, event, ...)
        local unit = ...
        if("player"==unit or event=="PLAYER_ENTERING_WORLD") then
            self.found = false
            self:SetAlpha(1)
            for i=1, 40 do
                local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitAura("player", i, "HELPFUL")
                if((data.isMine~=1 or "player") and (name==GetSpellInfo(44544))) then
                    self.found = true
                    self.count:SetText(count)
                    break
                end
            end
            if(not self.found) then
                self:SetAlpha(0)
                self.count:SetText("")
            end
        end
    end)
    frame.count = frame:CreateFontString(nil, "OVERLAY")
    frame.count:SetFont("Fonts\\FRIZQT__.TTF", FoFfontSize, "THICKOUTLINE")
    frame.count:SetTextColor(1, 1, 1)
    frame.count:SetPoint("CENTER", 0, 0)
    frame.count:SetJustifyH("CENTER")
    frame:SetFrameStrata("HIGH")
    enabled = nil
end

if(FrostyEmbrace_FoF) then
	if (class=="MAGE") then
		FrostyEmbrace_CreateFoF(FrostyEmbrace_FoF)
	end
end

--Let's create our BF tracker!
local function FrostyEmbrace_CreateBF(data)
    local frame = CreateFrame("Frame", "FrostyEmbrace_BF", UIParent)
    frame:SetWidth(2)
    frame:SetHeight(2)
    frame:SetPoint(unpack(data.setPoint))
    frame:RegisterEvent("UNIT_AURA")
	frame:RegisterEvent("PLAYER_REGEN_DISABLED") -- hopefully fixes 7.2.5 issues
    frame:RegisterEvent("PLAYER_TARGET_CHANGED")
    frame:RegisterEvent("PLAYER_ENTERING_WORLD")
    frame:SetScript("OnEvent", function(self, event, ...)
        local unit = ...
        if("player"==unit or event=="PLAYER_ENTERING_WORLD") then
            self.found = false
            self:SetAlpha(1)
            for i=1, 40 do
                local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitAura("player", i, "HELPFUL")
                if(("player") and (name==GetSpellInfo(190446))) then
                    self.found = true
					if (duration) then
						if(duration>=0) then
							self.cooldown:Show()
							CooldownFrame_Set(self.cooldown, expirationTime-duration, duration, 1)
						else
							self.cooldown:Hide()
						end
					else
						self.cooldown:Hide()
					end
                    break
                end
            end
            if(not self.found) then
                self:SetAlpha(0)
                self.cooldown:Hide()
            end
        end
    end)
	
	frame.icon = frame:CreateTexture("$parentIcon", "BACKGROUND")
    frame.cooldown = CreateFrame("Cooldown", nil, frame, "CooldownFrameTemplate")
	frame.cooldown:SetDrawSwipe(false)
	frame.cooldown:SetScale(BFScale)
    enabled = nil
end
if(FrostyEmbrace_BF) then
	if (class=="MAGE") then
		FrostyEmbrace_CreateBF(FrostyEmbrace_BF)
	end
end

--Let's create our Icicle tracker!
local function FrostyEmbrace_CreateIcicle(data)
	local frame = CreateFrame("Frame", "FrostyEmbrace_Icicle", UIParent)
	frame:SetWidth(10)
	frame:SetHeight(10)
	frame:SetPoint(unpack(data.setPoint))
	frame:RegisterEvent("UNIT_AURA")
	frame:RegisterEvent("PLAYER_TALENT_UPDATE")
	frame:RegisterEvent("PLAYER_REGEN_DISABLED") -- hopefully fixes 7.2.5 issues
	frame:RegisterEvent("PLAYER_TARGET_CHANGED")
	frame:RegisterEvent("PLAYER_ENTERING_WORLD")
	frame:SetScript("OnEvent", function(self, event, ...)
		local _,_,_,active = GetTalentInfo(7,2,1)
		if active == true then
			frame:Show()
			local unit = ...
				if("player"==unit or event=="PLAYER_ENTERING_WORLD") then
					self.found = false
					self:SetAlpha(1)
					for i=1, 40 do
						local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitAura("player", i, "HELPFUL")
						if((data.isMine~=1 or "player") and (name==GetSpellInfo(205473))) then
							self.found = true
							self.count:SetText(count)
							break
						end
					end
					if(not self.found) then
						self:SetAlpha(0)
						self.count:SetText("")
					end
				end
		elseif active == false then
			frame:Hide()
		end
	end)
	frame.count = frame:CreateFontString(nil, "OVERLAY")
	frame.count:SetFont("Fonts\\FRIZQT__.TTF", FoFfontSize, "THICKOUTLINE")
	frame.count:SetTextColor(1, 1, 1)
	frame.count:SetPoint("CENTER", 0, 0)
	frame.count:SetJustifyH("CENTER")
	frame:SetFrameStrata("HIGH")
	enabled = nil
end

if(FrostyEmbrace_Icicle) then
	if (class=="MAGE") then
		FrostyEmbrace_CreateIcicle(FrostyEmbrace_Icicle)
	end
end